#####################################################################################
# Copyright 2013 Normation SAS
#####################################################################################
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, Version 3.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#####################################################################################

# This file contain the Global Parameters, to be available within all
# promises, in the form ${rudder_parameters.parameterName}

# WARNING: This syntax will be deprecated, use the new one defined below ("rudder.parameters[]").

bundle common rudder_parameters {
  vars:
&RUDDER_PARAMETERS:{parameter |    "&parameter.parameterName&" string => "&parameter.escapedValue&";
}&
}


# Read rudder global parameters and put them into the rudder bundle
#
# Parameters are available using the rudder.parameters container that contains the values
# Those values are read from /var/rudder/cfengine-community/inputs/rudder-parameters.json
# 
# The file must contain at least a 2 levels JSON content, the first level is the namespace level
# (namely parameters) and the second level is the key level.
# The namespace name must comply with CFEngine variable names rules (ie [a-zA-Z_]+)
#

# The result key is available in the rudder.<namespace> data variable
# usage example: ${rudder.parameters[my_global_parameter]}
#
bundle agent rudder_global_parameters
{
  vars:
    # The files to read
    "parameters_file" string => "${this.promise_dirname}/../../rudder-parameters.json";

    # Read the files, 10MB maximum
    "parameters" data => readjson("${parameters_file}", "10000000");

    # Get namespace names
    "namespaces" slist => getindices("parameters");

    # Define the result variable
    "rudder.${namespaces}" data => mergedata("parameters[${namespaces}]", "{}");
}

